package com.itechnotion.wpnews.allFeaturesNews;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.text.Html;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.itechnotion.wpnews.Evenements.EvenmentDataBean;
import com.itechnotion.wpnews.NewsDetailActivity;

import com.itechnotion.wpnews.R;
import com.itechnotion.wpnews.retrofit.RestClient;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class AllFeaturesActivity extends AppCompatActivity implements View.OnClickListener, AllFeaturenewsAdapter.NewsItemClickListener, AllFeaturenewsAdapter.OnLoadMoreListener {
    ProgressDialog progressDialog;
    AllFeaturenewsAdapter newsByIDAdapter;
    ArrayList<EvenmentDataBean> newslist = new ArrayList<EvenmentDataBean>();
    RecyclerView rvNews;
    LinearLayout llNoDataFound;
    Toolbar toolbar;
    String newsId;
    String catId;
    String parentId;
    ImageView ivBackBtn;
    public static TextView tvToolbarTitle;
    private int per_page = 1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_all_features);
        initView();
        ProgressDialogSetup();
        getNewsByCatID(per_page);
    }

    private void initView() {
        toolbar = findViewById(R.id.toolbar);
        ivBackBtn = findViewById(R.id.ivBackBtn);
        ivBackBtn.setOnClickListener(this);
        tvToolbarTitle = findViewById(R.id.tvToolbarTitle);
        setSupportActionBar(toolbar);
        rvNews = (RecyclerView) findViewById(R.id.rvNews);
        llNoDataFound = findViewById(R.id.llNoDataFound);
    }

    private void ProgressDialogSetup() {
        progressDialog = new ProgressDialog(AllFeaturesActivity.this);
        progressDialog.setMessage(getResources().getString(R.string.please_wait));
        progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        progressDialog.setCancelable(false);
    }

    private void getNewsByCatID(final int per_page) {
        if (per_page == 1) {
            progressDialog.show();
        }
        Call<JsonElement> call = RestClient.post().getAllLatestNews(catId, per_page);
        call.enqueue(new Callback<JsonElement>() {
            @Override
            public void onResponse(Call<JsonElement> call, Response<JsonElement> response) {
                progressDialog.dismiss();
                try {
                    if (response.isSuccessful()) {
                        JSONArray jsonArr = new JSONArray(response.body().toString());
                        if (per_page == 1) {
                            for (int i = 0; i < jsonArr.length(); i++) {
                                JSONObject json2 = jsonArr.getJSONObject(i);
                                String id = json2.getString("id");
                                JSONObject objtitle = json2.getJSONObject("title");
                                String title = objtitle.getString("rendered");
                                String dateString = json2.getString("date");
                                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
                                DateFormat targetFormat = new SimpleDateFormat("MMMM dd yyyy");
                                String formattedDate = null;
                                Date convertedDate = new Date();
                                try {
                                    convertedDate = dateFormat.parse(dateString);
                                    System.out.println(dateString);
                                    formattedDate = targetFormat.format(convertedDate);
                                } catch (ParseException e) {
                                    e.printStackTrace();
                                }
                                Log.e("date", formattedDate);
                                String category = null;
                                String img = json2.getString("featured_image_link");
                                JSONArray cattitle = json2.getJSONArray("category_arr");
                                for (int j = 0; j < cattitle.length(); j++) {
                                    JSONObject cat = cattitle.getJSONObject(j);
                                    parentId = cat.getString("parent");
                                    category = String.valueOf(Html.fromHtml(cat.getString("name")));
                                }
                                newslist.add(new EvenmentDataBean(id, title, formattedDate, /*unlike,*/ img, category));
                                bindCategoryAdapter();
                            }
                        } else {
                            newslist.remove(newslist.size() - 1);
                            newsByIDAdapter.notifyItemRemoved(newslist.size());
                            for (int i = 0; i < jsonArr.length(); i++) {
                                JSONObject json2 = jsonArr.getJSONObject(i);
                                String id = json2.getString("id");
                                JSONObject objtitle = json2.getJSONObject("title");
                                String title = objtitle.getString("rendered");
                                String dateString = json2.getString("date");
                                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
                                DateFormat targetFormat = new SimpleDateFormat("MMMM dd yyyy");
                                String formattedDate = null;
                                Date convertedDate = new Date();
                                try {
                                    convertedDate = dateFormat.parse(dateString);
                                    System.out.println(dateString);
                                    formattedDate = targetFormat.format(convertedDate);
                                } catch (ParseException e) {
                                    e.printStackTrace();
                                }
                                Log.e("date", formattedDate);
                                String category = null;
                                String img = json2.getString("featured_image_link");
                                JSONArray cattitle = json2.getJSONArray("category_arr");
                                for (int j = 0; j < cattitle.length(); j++) {
                                    JSONObject cat = cattitle.getJSONObject(j);
                                    parentId = cat.getString("parent");
                                    category = String.valueOf(Html.fromHtml(cat.getString("name")));
                                }
                                newslist.add(new EvenmentDataBean(id, title, formattedDate,/* unlike,*/ img, category));
                                newsByIDAdapter.notifyDataSetChanged();
                                newsByIDAdapter.setLoaded();
                            }
                        }
                    } else {
                        progressDialog.dismiss();
                        newslist.remove(newslist.size() - 1);
                        newsByIDAdapter.notifyItemRemoved(newslist.size());
                        Toast.makeText(AllFeaturesActivity.this, "No recored available", Toast.LENGTH_SHORT).show();
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }

            @Override
            public void onFailure(Call<JsonElement> call, Throwable t) {
                progressDialog.dismiss();
                Log.e("LoginRes", t.toString());
            }
        });
    }

    private void bindCategoryAdapter() {

        if (newslist.size() > 0) {
            llNoDataFound.setVisibility(View.GONE);
            rvNews.setVisibility(View.VISIBLE);
            newsByIDAdapter = new AllFeaturenewsAdapter(AllFeaturesActivity.this, newslist, rvNews);
            newsByIDAdapter.setOnLoadMoreListener(this);
            newsByIDAdapter.setOnNewsItemClickListener(this);
            rvNews.setAdapter(newsByIDAdapter);
        } else {
            llNoDataFound.setVisibility(View.VISIBLE);
            rvNews.setVisibility(View.GONE);
        }
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.ivBackBtn:
                onBackPressed();
                break;
        }
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    public void OnNewItemClickListener(EvenmentDataBean bean, int position) {
        newsId = newslist.get(position).getId();
        Intent intent = new Intent(AllFeaturesActivity.this, NewsDetailActivity.class);
        intent.putExtra("NewsID", newsId);
        // intent.putExtra("CATEGORY_IDS",parentId);
        startActivity(intent);

    }

    @Override
    public void onLoadMore() {
        progressDialog.dismiss();
        Log.e("haint", "Load More");
        if (!newsByIDAdapter.isLoading) {
            newslist.add(null);
            newsByIDAdapter.notifyDataSetChanged();
            per_page++;
            getNewsByCatID(per_page);
        }
    }
}
